clear
clc
% close all

while(1)

    % % initialize serial port
    % s = serialport("COM5",115200);
    % read(s,36,"string")
    
    % get data in from mcu log file
    % set filepath to what it is on demo day
    dataIn = readtable('C:/Users/linds/OneDrive/Desktop/WCUBE_DEV_V2/logs/device-monitor-240503-112203.log', 'FileType', 'text');
    dataIn = dataIn(:,1);
    dataIn = table2array(dataIn);
    
    % data = table2array(data(:,[2 4]));
    data = table();
    
    % Loop through the string values ind the original table
    for i = 1:height(dataIn)
        % Get the string value at index i
        str = dataIn(i,1);
        
        % Check if the string starts with 'Phase'
        if startsWith(str, 'Phase')
            % Add the string to the new table
            data = [data; dataIn(i, 1)];
        end
    end
    
    data = table2array(data);
    data = split(data);
    data = str2double(data(:,[2 4]));
    
    % initialize vars
    thetaArray = data(:,1);
    detectorVoltsArray = data(:,2);
    % detectorValueArray = [];
    
    % plot on polar axis
    figure(1);
    ax = polaraxes;
    
    theta = thetaArray;
    detectorVolts = detectorVoltsArray;
    
    polarplot(theta, detectorVolts, '*');
    hold on
    
    title("Beamscanning Results: mV Detected over Phase (0-180 degrees)");
    
    radiusregion(200,400,FaceColor='g');
    
    ax.ThetaLim = [0 180];
    ax.RLim = [0 500];
    ax.FontSize = 6;
    
    thetaticks(0:5:180);
    rticks(0:25:500);
    
end

% save plot & data file to desired filepath for later   
% set filepath to wherever you want it to go
f = gcf;
exportgraphics(f,'C:/Users/linds/OneDrive/Desktop/SD Demo Visualizaion/Visualization Outputs/beamscan-visualization-240503-111802.png');
writematrix(data,'C:/Users/linds/OneDrive/Desktop/SD Demo Visualizaion/Value Outputs/beamscan-values-240503-111802.xls')