#include <vector>
#include <Arduino.h>
#include <stdio.h>
#include <stdlib.h>
#include <SPI.h>
#include <vector>
#include <string>
#include <SPIFFS.h>
#include <Preferences.h>

double powerDetect(float theta){
    Serial.println("powerDetect");
        //////  -- ADC Code --  //////
        // start detecting DC
        pinMode(1, INPUT); 
        analogReadResolution(12);

        // initialize variables
        double detectorValue = 0;
        double detectorVolts = 0; 
        double detectorValueTot = 0;
        double detectorVoltsTot = 0;

        // 10 measurement hold to read out from GPIO 1 (pin39, ADC1_CH0) 
        for (int i = 0; i<10; i++){
            // get detector values
            detectorValue = analogRead(1);
            detectorVolts = analogReadMilliVolts(1);

            // print current detector values (DEV)
            //Serial.print("Raw Value = ");
            //Serial.println(detectorValue);
            //Serial.print("mV Value = ");
            //Serial.println(detectorVolts);
        
            // add to running total for this iteration
            detectorValueTot += detectorValue;
            detectorVoltsTot += detectorVolts;
        
            // delay for clean reads
            // needs to be vTaskDelay so that we go to the Power_Monitor task 
            vTaskDelay(100); 
        }

    double detectorVoltsAvg = detectorVoltsTot / 10;

    //dataPackage = (String) startData + theta + separatorData + detectorVoltsAvg + endData;
    Serial.print("Phase ");
    Serial.print(theta);
    Serial.print(" Voltage ");
    Serial.println(detectorVoltsAvg);

    delay(1000);

    return detectorVoltsAvg;
} 

/* to put in main under ANTENNA_OP
    std::vector<double> outputValues;

    outputValues.push_back(detectorVoltsAvg);
    writeArrayCSV(outputValues, "/PDOutputVolts.csv");
*/