#include "csvFunctions.h"
#include <Arduino.h>
#include <SPIFFS.h>
#include <Preferences.h>
#include <FS.h>
#include <vector>
#include <string>
using namespace std;

/*
1) Remember create a folder titled 'data' within the project. 
2) Then add the file you want to read from to the data folder
3) Then click the projectIO icon and select the board name
4) Underplatform select 'Build Filesystem Image'
5) Next select 'Upload Filesystem Image'
6) Now you are able to run the script and successfully read from the file included in the data folder
*/

vector<string> column1;
vector<string> column3;

// Function to read the CSV file and print columns 1 and 3 to the Serial monitor
void readCSVFile() {
  // Open the CSV file
  File file = SPIFFS.open("/parseTest.csv", "r");
  
  if (!file) {
    Serial.println("Failed to open file for reading");
    return;
  } else {
    Serial.println("Successful File Read");
  }

  // Read each line of the file
  while (file.available() != 0) {
   String line = file.readStringUntil('\n');
    int firstCommaIdx = line.indexOf(',');
    int secondCommaIdx = line.indexOf(',', firstCommaIdx + 1);
    int thirdCommaIdx = line.indexOf(',', secondCommaIdx + 1);

    if (firstCommaIdx != -1 && secondCommaIdx != -1) {
      String col1 = line.substring(0, firstCommaIdx);
      String col3 = line.substring(secondCommaIdx + 1, thirdCommaIdx);

      column1.push_back(col1.c_str());
      column3.push_back(col3.c_str());
    }

  }

  // Close the file
  file.close();

  Serial.println("Column 1 Values:");
  for (const auto& value : column1) {
    Serial.println(value.c_str());
  }

  Serial.println("Column 3 Values:");
  for (const auto& value : column3) {
    Serial.println(value.c_str());
  }

}

void printCSV() {
  delay(5000);
  Serial.begin(115200);
  Serial.println("Start Test");
  
  // Initialize SPIFFS
  if (!SPIFFS.begin(true)) {
    Serial.println("Failed to mount file system");
    return;
  } else {
    Serial.println("Successful file system mount");
  }

  // Call function to read and print data from CSV file
  readCSVFile();
          
}
