#include "motorFunctions.h"
#include <Arduino.h>
#include <Stepper.h> 

Stepper Stepper1(STEPS, 7, 16, 15, 17);


float lambda ; 
float lambdaActual = 0.0;
int speed ;
int stepCount = 0; 

void motorSetup() //Set up motors with initial speed and lambda value
{
    Serial.println("Motor Control Version 3: Setup Begin");  
    Serial.println(" ");
    //lambda = setLambda();
    speed = setSpeed();
}

/////////////////////////////////////////////////////////////////////////////////////

void moveMotor(float position) 
{
    int numSteps = position/LINEAR_PER_STEP;
    int stepsToMove = numSteps - stepCount;

    Serial.print("Current steps: ");
    Serial.println(stepCount);
    Serial.print("Current positon: ");
    Serial.println(stepCount*LINEAR_PER_STEP);
    Serial.println(" ");

    Stepper1.step(stepsToMove);
    stepCount += stepsToMove;

    Serial.print("Final steps: ");
    Serial.println(stepCount);
    Serial.print("Final positon: ");
    Serial.println(stepCount * LINEAR_PER_STEP);
    lambdaActual = stepCount * LINEAR_PER_STEP;
}

/////////////////////////////////////////////////////////////////////////////////////

float getPosition()
{
 return(0);
}

/////////////////////////////////////////////////////////////////////////////////////

float setLambda()
{
    Serial.println("Enter desired lambda value in mm");
    lambda = 0;
    while (lambda == 0)
    {
      lambda = Serial.parseInt();
    }

  Serial.print("Lambda has been set too: ");
  Serial.println(lambda);
  return(lambda);
}

/////////////////////////////////////////////////////////////////////////////////////

int setSpeed()
{
Serial.println("Enter desired motor speed in RPM(0,100]");
speed = 0;
  while (speed == 0)
  {
      speed = Serial.parseInt();
  }
  Stepper1.setSpeed(speed);
  Serial.print("The motor speed has been set too: ");
  Serial.println(speed);
  return(speed);
}