#include <Arduino.h>
#include <stdio.h>
#include <stdlib.h>
#include <SPI.h>
#include <vector>
#include <string>
#include <SPIFFS.h>
#include <Preferences.h>

using namespace std;

#define MAX_LINES 100  // Maximum lines to read (adjust as needed)
#define CS 9 //used to be 5
#define MOSI 10 //used to be 10
#define SCK 11 //used to be 8
#define MISO 12 //used to be 9

const char* Adress[MAX_LINES];
const char* Reg[MAX_LINES];
const char* Value[MAX_LINES];
int lineCount = 0;
int AdressNum[MAX_LINES];
int RegNum[MAX_LINES];
int ValueNum[MAX_LINES];

byte modeLatch = 0b00101000;
byte RD_Mode = 0b00000000;
byte LUT_WR_Mode = 110;
byte chipAdress = 0b00000000;



void parseCSVLine(const String& line) {
  int column = 0;
  int lastComma = -1;
  String columns[6];  // enter the number of columns that you have

  for (int currentPos = 0; currentPos < line.length(); currentPos++) {
    if (line[currentPos] == ',' || currentPos == line.length() - 1) {
      String data = line.substring(lastComma + 1, currentPos);
      if (column == 3 || column == 4 || column ==5) {  // Column indices 0 and 2 correspond to columns 1 and 3
        columns[column] = data;
      }
      lastComma = currentPos;
      column++;
    }
  }

  if (lineCount < MAX_LINES) {
    Adress[lineCount] = strdup(columns[3].c_str());
    Reg[lineCount] = strdup(columns[4].c_str());
    Value[lineCount] = strdup(columns[5].c_str());
    lineCount++;
  }

}

void runSpi() {
  /*Serial.begin(115200);
  delay(5000);

  if (!SPIFFS.begin()) {
    Serial.println("An Error has occurred while mounting SPIFFS");
    return;
  }*/

  File file = SPIFFS.open("/RegLog.csv", "r");
  if (!file) {
    Serial.println("Failed to open file for reading");
    return;
  }

  while (file.available() && lineCount < MAX_LINES) {
    String line = file.readStringUntil('\n');
    parseCSVLine(line);
  }

  file.close();
  
  // Print the results
  for (int i = 0; i < lineCount; i++) {
    Serial.print("Column 4: ");
    Serial.print(Adress[i]);
    Serial.print(", Column 5: ");
    Serial.print(Reg[i]);
    Serial.print(", Column 6: ");
    Serial.println(Value[i]);
  }
  

  for (int i = 0; i < lineCount; i++) {
    AdressNum[i] = stoi(Adress[i], nullptr, 16);
    RegNum[i] = stoi(Reg[i], nullptr, 16);
    ValueNum[i] = stoi(Value[i], nullptr, 16);
  }


//AdressNum[1] = stoi(Adress[1], nullptr, 16);
//RegNum[1] = stoi(Reg[1], nullptr, 16);
//ValueNum[1] = stoi(Value[1], nullptr, 16);

  SPI.begin(SCK, MISO, MOSI, CS); // Initialize SPI communication
  pinMode(CS, OUTPUT); // Set SS pin as output
  digitalWrite(CS, HIGH); // Set SS pin high initially (deselect the s
  SPI.beginTransaction(SPISettings(1000000, MSBFIRST, SPI_MODE0));

  digitalWrite(CS, LOW); // Select the slave
  
  for (int i = 0; i < lineCount; i++) 
  {

    //Serial.print("Writing to Register: ");
   // Serial.println(RegNum[i], HEX);
    //SPI.transfer(RegNum[i]);
    //Serial.print("Value Written: ");
    //Serial.println(ValueNum[i], HEX);
    byte msb = (ValueNum[i] >> 8) & 0xFF; // Extract most significant byte
    byte lsb = ValueNum[i] & 0xFF;
    SPI.transfer(RD_Mode); //mode is first 3 bits (This is LCL_REG_RD), next are reserved
    SPI.transfer(chipAdress); // first is reserved last 7 are device adress
    SPI.transfer(RegNum[i]); // first is reserved last 7 are register adress
    SPI.transfer(msb); //DR: D15:D8 MSB
    SPI.transfer(lsb); //DR: D7:D0 LSB
    //SPI.transfer(ValueNum[i]);
    //Serial.println(i);
    //Serial.println(msb,HEX);
    //Serial.println(lsb,HEX);
    //Serial.println(ValueNum[i],HEX);
  }



delay(500);
digitalWrite(CS, HIGH); // Deselect the slave

}
