#include <Arduino.h>
#include <Wire.h>

#define SDA_PIN 4//4  // Change to your SDA pin
#define SCL_PIN 5//5 // Change to your SCL pin


int configReg() {
  Wire.beginTransmission(0x40); // Begins transmission to I2C device at address
  Wire.write(0x00);
  Wire.endTransmission(); // Transmits bytes queued by write
  Wire.requestFrom(0x40, 1); // Requests 1 byte 
  if (Wire.available() ) {
    int config = Wire.read();
    return config;
  }
}

float readComp() {
  int highbit;
  int lowbit;
  Wire.beginTransmission(0x40); // Begins transmission to I2C device at address
  Wire.write(0x03);
  Wire.endTransmission(); // Transmits bytes queued by write
  Wire.requestFrom(0x40, 2); // Requests 2 bytes 
  
  while ( Wire.available() ) { // Runs if bytes can be read 
    highbit = Wire.read(); 
    lowbit = Wire.read();  
  }

  int value = (highbit << 1) | (lowbit >> 7); 
  float comp = value >> 1;

  return comp;
}

