#include <Arduino.h>
#include "spiFunctions.h"
#include <SPI.h>
#include <stdio.h>

// Pins for SPIx 


// configure spi pins
void spiSetup() {
    SPI1CON1bits.MSTEN = 1; // make controller
    SPI1CON1bits.PPRE = 0b11; // 1:1 primary prescale
    SPI1CON1bits.SPRE = 0b111; // 1:1 secondary prescale
    SPI1CON1bits.MODE16 = 0; // 8-bit transfer mode
    SPI1CON1bits.SMP = 0; // sample in middle
    SPI1CON1bits.CKE = 1; // Output on falling edge
    SPI1CON1bits.CKP = 0; // CLK idle state low
    SPI1STATbits.SPIEN = 1; // enable SPI1
}


void spiMessage()
{
    uint8_t address = 0x00; // weightArray[i][0]
    uint16_t value = 0x0007; // weightArray[i][1]

    // Initialize SPI communication
    pinMode(9, OUTPUT);
    digitalWrite(9, LOW);

    // Send write command followed by address
    // SPI.transfer(0x00);          // Write command
    SPI.transfer(address);          // BFIC register address 
    SPI.transfer16(value); // highByte(value));  // Send high byte, phase
    //SPI.transfer(lowByte(value));   // Send low byte, gain
      
    // End SPI communication
    digitalWrite(9, HIGH);
}









